; Chest handling routines

CHESTS = 100

;====================================================================

ClearChests:
 ld b,CHESTS
 ld hl,Chests
 ld a,(CurrMap)
 ld c,a
 ld de,3
ClearChestsLoop:
 ld a,(hl)
 cp c
 jr nz,ClearChestsNext
 push hl
 push de
 inc hl
 ld e,(hl)
 inc hl
 ld a,(hl)
 or a
 jr nz,ClearChestsSkip
 ld hl,Map
 ld d,0
 add hl,de
 ld (hl),EMPTYCHEST
ClearChestsSkip:
 pop de
 pop hl
ClearChestsNext:
 add hl,de
 djnz ClearChestsLoop
 ret

; de = first byte, bc = second byte
OpenChest:
 ld a,(de)
 cp CHEST_START
 jr c,OpenChestN
 cp CHEST_END+1
 jr c,OpenChestFound
OpenChestN:
 ld a,(bc)
 cp CHEST_START
 ret c
 cp CHEST_END+1
 ret nc
 ld d,b
 ld e,c
OpenChestFound:
 ex de,hl
 ld (_@OpenChestMap),hl
 ld de,$10000-Map
 add hl,de
 ld c,l
 ld a,(CurrMap)
 ld b,a
 ld de,3
 ld hl,Chests
 ld a,CHESTS
OpenChestLoop:
 push hl
 ld (_@OpenChestLoopC),a
 ld a,(hl)
 cp b
 jr nz,OpenChestsNext
 inc hl
 ld a,(hl)
 cp c
 jr nz,OpenChestsNext
 inc hl
 pop af
 ld a,(hl)
 or a
 ret z
 ld c,a
 ex de,hl
_@OpenChestMap =$+1
 ld hl,$ffff 
 ld a,(hl)
 cp NORMALCHEST
 jr nz,OpenChestSkipSetEmpty 
 ld (hl),EMPTYCHEST
 sub a
 ld (de),a
OpenChestSkipSetEmpty:
 call ChestGiveItem
 ld a,1
 ld (RedrawMap),a
 ret
OpenChestsNext:
 pop hl
 add hl,de
_@OpenChestLoopC =$+1
 ld a,0
 dec a
 jr nz,OpenChestLoop
 ret

; c = item number
ChestGiveItem:
 ld hl,ChestItems-2
 sla c
 ld d,0
 ld e,c
 add hl,de
 ld a,(hl)
 inc hl
 ld h,(hl)
 ld l,a
 jp (hl)

;  1 = 30 rupees
;  2 = key
;  3 = guy w/ shield (hack for map #2)
;  4 = sword
;  5 = 10 bombs
;  6 = boomerang
;  7 = feather
;  8 = raft
;  9 = bow and 10 arrows
; 10 = shop: 10 arrows
; 11 = shop: 10 bombs
; 12 = shop: refill 3 full hearts
; 13 = container heart
ChestItems:
 .dw ChestItem1, ChestItem2, ChestItem3, ChestItem4, ChestItem5,
 .dw ChestItem6, ChestItem7, ChestItem8, ChestItem9, ChestItem10,
 .dw ChestItem11, ChestItem12, ChestItem13

; (_@OpenChestMap) = pointer to map tile with chest
ChestItem1:
 ld a,3
 call PrintString
 ld a,30
 jp GivePlayerRupees

ChestItem2:
 ld hl,PlayerKeys
 inc (hl)
 ld a,10
 jp PrintString

ChestItem3:
 ld hl,(_@OpenChestMap)
 ld de,$10000-Map
 add hl,de
 ld c,l
 ld a,(CurrMap)
 ld b,a
 ld a,5
 push bc
 call AddToChangeList
 pop bc
 ld c,53                ; hack for starting off
 ld a,104               ; move villager closer inside house
 call AddToChangeList
 ld a,1
 call SetPlayerItems
 ld a,14
 jp PrintString

ChestItem4:
 ld a,2
 call SetPlayerItems
 ld a,15
 jp PrintString

ChestItem5:
 ld a,3
 call SetPlayerItems
 ld hl,PlayerBombs
 ld a,10
 add a,(hl)
 ld (hl),a
 ld a,17
 jp PrintString

ChestItem6:
 ld a,4
 call SetPlayerItems
 ld a,16
 jp PrintString

ChestItem7:
 ld a,5
 call SetPlayerItems
 ld a,18
 jp PrintString

ChestItem8:
 ld hl,PlayerSpecial
 set 0,(hl)
 ld a,19
 jp PrintString

ChestItem9:
 ld a,6
 call SetPlayerItems
 ld hl,PlayerArrows
 ld a,10
 add a,(hl)
 ld (hl),a
 ld a,22
 jp PrintString 

ChestItem10:
 ld a,24
 call PrintString
 ret nc
 ld hl,(PlayerRupees)
 ld de,-25
 add hl,de
 ld a,27
 jp nc,PrintString
 ld (PlayerRupees),hl
 ld a,10
 ld hl,PlayerArrows
 add a,(hl)
 ld (hl),a 
 ret

ChestItem11:
 ld a,25
 call PrintString
 ret nc
 ld hl,(PlayerRupees)
 ld de,-30
 add hl,de
 ld a,27
 jp nc,PrintString
 ld (PlayerRupees),hl
 ld a,10
 ld hl,PlayerBombs
 add a,(hl)
 ld (hl),a 
 ld a,3
 jp SetPlayerItems

ChestItem12:
 ld a,26
 call PrintString
 ret nc
 ld hl,(PlayerRupees)
 ld de,-10
 add hl,de
 ld a,27
 jp nc,PrintString
 ld (PlayerRupees),hl
 ld b,3
ChestItem12Loop:
 call GivePlayerHeart
 djnz ChestItem12Loop 
 ret

ChestItem13:
 ld hl,PlayerMaxLife
 ld a,2
 add a,(hl)
 ld (hl),a
 ld (PlayerLife),a
 ld a,11
 jp PrintString

.end
