; The Options Screen

Options:
 call ClearBuffers
 call CopyBuffers

OptionsClearText:
 ld hl,_plotSScreen
 ld de,_plotSScreen+1
 ld bc,1023
 ld (hl),0
 ldir
 set textwrite,(iy+new_grf_flgs)

 ld b,16
 ld a,b
 ld (RedrawMap),a
OptionsDrawH:
 push bc
 ld c,8
 dec b
 sla b
 sla b
 sla b
 ld hl,HorizontalBar
 call GraySprite 
 pop bc
 djnz OptionsDrawH
 ld b,6
OptionsDrawV:
 push bc
 ld c,b
 inc c
 sla c
 sla c
 sla c
 ld b,56
 ld hl,VerticalBar
 call GraySprite 
 pop bc
 djnz OptionsDrawV
 ld bc,$2000
 ld a,(PlayerLife)
 ld e,a
 rra
 or a
 jr z,OptionsDrawHeartS
 ld d,a
OptionsDrawHeart:
 push de
 push bc
 ld hl,BigHeart
 call GraySprite
 pop bc
 pop de
 ld a,8
 add a,b
 ld b,a
 dec d
 jr nz,OptionsDrawHeart
 bit 0,e
 jr z,OptionsDrawHeartD
OptionsDrawHeartS:
 push de
 push bc 
 ld hl,BigHalfHeart
 call GraySprite
 pop bc
 pop de
 ld a,8
 add a,b
 ld b,a
OptionsDrawHeartD:
 ld a,(PlayerMaxLife) 
 sub e
 rra
 or a
 jr z,OptionsDrawHeartT
 ld c,a
OptionsDrawHeartE:
 push bc
 ld c,0
 ld hl,EmptyHeart
 call GraySprite  
 pop bc
 ld a,8
 add a,b
 ld b,a
 dec c
 jr nz,OptionsDrawHeartE
OptionsDrawHeartT:
 ld bc,0
 ld hl,RupeeSpr
 call GraySprite
 ld hl,$0008
 ld (_penCol),hl
 ld hl,(PlayerRupees)
 call DispHL

OptionsShowKeys:
 ld hl,(18<<8)+74
 ld (_penCol),hl
 ld a,(PlayerKeys)
 call DispA
 ld bc,(64<<8)+16
 ld hl,BigKey
 call GraySprite

OptionsShowBombs:
 ld hl,PlayerItems
 ld a,(hl)
 cp 3
 jr c,OptionsShowBombsSkip
 ld bc,(88<<8)+16
 ld hl,BombIcon
 call GraySprite
 ld hl,(18<<8)+98
 ld (_penCol),hl
 ld a,(PlayerBombs)
 call DispA
OptionsShowBombsSkip:

OptionsShowArrows:
 ld hl,PlayerItems
 ld a,(hl)
 cp 6
 jr c,OptionsShowArrowsSkip
 ld hl,(30<<8)+98
 ld (_penCol),hl
 ld a,(PlayerArrows)
 call DispA
 ld bc,(88<<8)+28
 ld hl,ArrowIcon
 call GraySprite
OptionsShowArrowsSkip:

OptionsShowRaft:
 ld a,(PlayerSpecial)
 rra
 jr nc,OptionsShowRaftSkip
 ld bc,(64<<8)+40
 ld hl,RaftIcon
 call GraySprite 
OptionsShowRaftSkip:

OptionsShowText:
 res textwrite,(iy+new_grf_flgs)
 ld hl,_plotSScreen
 ld de,GrayMem1
 ld b,0
OptionsShowTextL:
 ld a,(de)
 or (hl)
 ld (de),a
 inc hl
 inc de
 ld a,(de)
 or (hl)
 ld (de),a
 inc hl
 inc de
 ld a,(de)
 or (hl)
 ld (de),a
 inc hl
 inc de
 ld a,(de)
 or (hl)
 ld (de),a
 inc hl
 inc de
 djnz OptionsShowTextL
 
; 0 = nothing, 1 = shield, 2 = sword, 3 = bombs, 4 = boomerang, 5 = feather, 6 = bow
OptionsDraw:
 ld a,(PlayerItems)
 cp 3
 jr c,OptionsDrawDone
 sub 3
 jr z,OptionsDraw3
 dec a
 jr z,OptionsDraw4
 dec a
 jr z,OptionsDraw5
OptionsDraw6:
 ld bc,(40<<8)+28
 ld hl,BowIcon
 call GraySprite
OptionsDraw5:
 ld bc,(8<<8)+28
 ld hl,FeatherIcon
 call GraySprite
OptionsDraw4:
 ld bc,(40<<8)+16
 ld hl,BoomerangIcon
 call GraySprite
OptionsDraw3:
 ld bc,(8<<8)+16
 ld hl,BombIcon
 call GraySprite
OptionsDrawDone:

 ld a,(ButtonBEquipped)
 ld e,a
OptionsEquip:
 push de
 call OptionsDrawCursor
 call ShowGray
 pop de
 push de
 call OptionsEraseCursor
 call _get_key
 pop de
 cp K_UP
 jr nz,OptionsEquipDown
 ld a,e
 sub 2
 and %00000111
 ld e,a
 jr OptionsEquip
OptionsEquipDown:
 cp K_DOWN
 jr nz,OptionsEquipLeft
 ld a,e
 add a,2 
 and %00000111
 ld e,a
 jr OptionsEquip
OptionsEquipLeft:
 cp K_LEFT
 jr nz,OptionsEquipRight
 ld a,%00000001
 xor e
 ld e,a
 jr OptionsEquip
OptionsEquipRight:
 cp K_RIGHT
 jr nz,OptionsEquip2nd
 ld a,%00000001
 xor e
 ld e,a
 jr OptionsEquip
OptionsEquip2nd:
 cp K_SECOND
 jr nz,OptionsEquipExit
 ld a,(PlayerItems)
 sub 3
 jr c,OptionsEquip
 cp e
 jr c,OptionsEquip
 ld a,e
 inc a
 ld (ButtonBEquipped),a
 jp EndInput
OptionsEquipExit:
 cp K_EXIT
 jp z,EndInput
 cp K_MORE
 jp z,EndInput 
 jr OptionsEquip

OptionsDrawCursor:
 ld hl,OptionsCursorTable
 ld d,0
 add hl,de
 add hl,de
 ld c,(hl)
 inc hl
 ld b,(hl)
 ld hl,SelectLeftSpr
 push bc
 call GraySprite
 pop bc
 ld a,16
 add a,b
 ld b,a
 ld hl,SelectRightSpr
 call GraySprite
 ret

OptionsEraseCursor:
 ld hl,OptionsCursorTable
 ld d,0
 add hl,de
 add hl,de
 ld c,(hl)
 inc hl
 ld b,(hl)
 ld hl,BlankSpr
 push bc
 call GraySprite
 pop bc
 ld a,16
 add a,b
 ld b,a
 ld hl,BlankSpr
 call GraySprite
 ret

OptionsCursorTable:
 .dw (0<<8)+16, (32<<8)+16, (0<<8)+28, (32<<8)+28, (0<<8)+40, (32<<8)+40, (0<<8)+52, (32<<8)+52

; in: a or hl = number to print
DispA:
 ld l,a
 ld h,0
DispHL:
 ld de,_OP1+5
 sub a
 ld (de),a
DispLoop:
 call _divHLby10
 add a,'0'
 dec de
 ld (de),a
 ld a,h
 or l
 jr nz,DispLoop
 ex de,hl
 jp _vputs 

.end
